;  DOS-Mode driver for the Microsoft Sidewinder Gamepad
;  Multi-Controller version
;  (C) 1997, 1998 Robert William Grubbs, All Rights Reserved
;  Latest revision 1/17/98

   .MODEL compact        ;using simplified segments for now
   .STACK 0400h
   .DATA
   .386

gDump db 2000h DUP (0)   ;DMA/HDMA registers
dispPage dw 0
   .CODE

   mov ax,@DATA
   mov ds,ax

;The original test program
   SWLoop:
   mov cx,900
   mov bx,0
   mov dx,0201h
   GetSWDataLoop:
   out dx,al
   in al,dx
   mov ds:[gDump+bx],al
   inc bx
   loop GetSWDataLoop

   mov cx,64000
   DelayLoop:
   push cx
   pop cx
   push cx
   pop cx
   dec cx
   jnz DelayLoop
   

   mov cx,900
   GetSWDataLoop2:
   out dx,al
   in al,dx
   mov ds:[gDump+bx],al
   inc bx
   loop GetSWDataLoop2


   SWDispLoop:
   call CLS
   call COLCOL
   call DispBin
   mov dx,bx
   call DispWord

   SWKBLoop:
   mov ah,0
   int 16h
   cmp al,'q'
   je SWEnd
   cmp al,'Q'
   je SWEnd
   cmp al,27 
   je SWEnd
   cmp al,' '
   je SWLoop
   cmp al,'1'
   je Page1
   cmp al,'2'
   je Page2
   cmp al,'3'
   je Page3
   cmp al,'4'
   je Page4
   cmp al,'5'
   je Page5
   cmp al,'6'
   je Page6
   cmp al,'7'
   je Page7
   cmp al,'8'
   je Page8
   cmp al,'9'
   je Page9
   cmp al,'0'
   je Page0
   jmp SWKBLoop

   Page1:
   mov dispPage,0
   jmp SWDispLoop
   Page2:
   mov dispPage,200
   jmp SWDispLoop
   Page3:
   mov dispPage,400
   jmp SWDispLoop
   Page4:
   mov dispPage,600
   jmp SWDispLoop
   Page5:
   mov dispPage,800
   jmp SWDispLoop
   Page6:
   mov dispPage,1000
   jmp SWDispLoop
   Page7:
   mov dispPage,1200
   jmp SWDispLoop
   Page8:
   mov dispPage,1400
   jmp SWDispLoop
   Page9:
   mov dispPage,1600
   jmp SWDispLoop
   Page0:
   mov dispPage,1800
   jmp SWDispLoop

   SWEnd:
   mov ah,04ch
   int 21h



DispDigit MACRO
  LOCAL Disp1,EndDispDigit
  jnz SHORT Disp1
  mov BYTE PTR es:[di+bx],'1'
  jmp SHORT EndDispDigit
  Disp1:
  mov BYTE PTR es:[di+bx],'0'
  EndDispDigit:
ENDM

DispBin PROC NEAR
  mov ax,0b800h
  mov es,ax
  mov di,0
  mov bx,0
  mov si,[dispPage]
  mov cx,0A14h
  mov ax,0
  DispLoop:
  mov bx,ax
  test ds:[gDump+si],80h
  DispDigit
  inc bx
  inc bx
  test ds:[gDump+si],40h
  DispDigit
  inc bx
  inc bx
  test ds:[gDump+si],20h
  DispDigit
  inc bx
  inc bx
  test ds:[gDump+si],10h
  DispDigit
  inc bx
  inc bx
  test ds:[gDump+si],08h
  DispDigit
  inc bx
  inc bx
  test ds:[gDump+si],04h
  DispDigit
  inc bx
  inc bx
  test ds:[gDump+si],02h
  DispDigit
  inc bx
  inc bx
  test ds:[gDump+si],01h
  DispDigit
  inc bx
  inc bx

  inc si
  add di,160
  dec cl
  jnz DispLoop
  mov di,0
  add ax,16
  mov cl,14h
  dec ch
  jnz DispLoop
  ret
ENDP

CLS PROC
  mov ax,0B800h
  mov es,ax
  mov di,0
  mov cx,2000
  CLSLoop:
  mov BYTE PTR es:[di],0
  inc di
  inc di
  loop CLSLoop
  ret
ENDP
COLCOL PROC
  mov ax,0B800h
  mov es,ax
  mov di,1
  mov cx,2000
  COLLoop:
  mov bx,cx
  dec bx
  and bx,8
  shr bx,3
  add bl,7
  mov BYTE PTR es:[di],bl
  inc di
  inc di
  loop COLLoop
  ret
ENDP

;In:  di=timeout (in loops)
;Out: bx=buttons  (0=up 1=dn 2=rt 3=lt 4=A 5=B 6=C 7=X)
;                 (8=Y  9=Z 10=L 11=R 12=? 13=St 14=M )
SWStatus PROC NEAR

  mov dx,0201h                ;Joystick port address
  mov cx,0                    ;tick count
  mov si,1                    ;initialize output mask
  mov bx,0                    ;initialize output

  WaitForCycle:
  out dx,al                   ;trap port (send giberish)
  in al,dx                    ;get SW status byte
  dec di                      ;Check for time-out
  jz SWDone                   ;
  test al,00100000b           ;Check for zero bits
  jnz SHORT WFCS1             ;
  xor cx,cx                   ;if zero, reset tick count
  jmp SHORT WaitForCycle
  WFCS1:
  test al,00010000b           ;Check for zero bits
  jnz SHORT WFCS2             ;
  xor cx,cx                   ;if zero, reset tick count
  jmp SHORT WaitForCycle
  WFCS2:
  test al,00001110b           ;check for "tick"
  jnz SHORT WaitForCycle      ;if no tick, get next status byte
  inc cx                      ;increment tick count
  cmp cx,2                    ;test for sufficient ticks for cycle start
  jne SHORT WaitForCycle      ;if insufficient, get next status byte

  WaitForStrobeLow:
  dec di                      ;Check for time-out
  jz SWDone                   ;
  out dx,al                   ;trap port (send giberish)
  in al,dx                    ;get SW status byte
  test al,00010000b
  jnz SHORT WaitForStrobeLow

  WaitForStrobeHigh:
  dec di                      ;Check for time-out
  jz SWDone                   ;
  out dx,al                   ;trap port (send giberish)
  in al,dx                    ;get SW status byte
  test al,00010000b
  jz SHORT WaitForStrobeHigh
  shl si,1
  test al,00100000b
  jnz SHORT WaitForStrobeLow
  or bx,si
  cmp si,8000h
  je SHORT SWDone
  jmp SHORT WaitForStrobeLow

  SWDone:

  ret
ENDP

DispWord PROC NEAR
  mov ax,0b800h
  mov es,ax
  mov bx,0
  mov di,0
  test dh,80h
  DispDigit
  inc bx
  inc bx
  test dh,40h
  DispDigit
  inc bx
  inc bx
  test dh,20h
  DispDigit
  inc bx
  inc bx
  test dh,10h
  DispDigit
  inc bx
  inc bx
  test dh,08h
  DispDigit
  inc bx
  inc bx
  test dh,04h
  DispDigit
  inc bx
  inc bx
  test dh,02h
  DispDigit
  inc bx
  inc bx
  test dh,01h
  DispDigit
  inc bx
  inc bx
  mov dh,dl
  test dh,80h
  DispDigit
  inc bx
  inc bx
  test dh,40h
  DispDigit
  inc bx
  inc bx
  test dh,20h
  DispDigit
  inc bx
  inc bx
  test dh,10h
  DispDigit
  inc bx
  inc bx
  test dh,08h
  DispDigit
  inc bx
  inc bx
  test dh,04h
  DispDigit
  inc bx
  inc bx
  test dh,02h
  DispDigit
  inc bx
  inc bx
  test dh,01h
  DispDigit
  inc bx
  inc bx
  ret
ENDP

;The main subroutine;  this is the important one;  bow down before it
;IN: none
;Out: bx=buttons  (bit 0=null 1=up 2=dn 3=rt 4=lt 5=A 6=B 7=C 8=X)
;                 (9=Y 10=Z 11=L 12=R 13=St 14=M 15=Parity)
;No registers destroyed (besides BX, of course)
bDump db 10h DUP (0)    ;buffer to hold button data for mode B
SWStatus PROC
  push ax
  push cx
  push dx
  push si
  push di
  push bp

  ;implementation note:  interrupt processing may mess up the SW data,
  ; so it may be necessary to disable interrupts during the SW dump below
  ;I havn't had problems so far, but just in case, I thought I'd warn you...

  mov cx,200                  ;dump buffer fill size
  mov bx,0                    ;initial dump pointer
  mov dx,0201h                ;joystick port
  ;cli                         ;uncomment to disble interrupts
  GetSWDataLoop:              ;
  out dx,al                   ;trigger joystick port
  in al,dx                    ;read SW status byte
  mov cs:[gDump+bx],al        ;dump status byte
  inc bx                      ;increment dump pointer
  loop GetSWDataLoop          ;get next status byte (quickly)
  ;sti                         ;uncomment to disble interrupts

  mov cx,0                    ;tick count
  mov si,1                    ;initialize output mask
  mov bx,0                    ;initialize output
  mov di,0                    ;initialize input pointer

  ;My current method of cycle detection is to look for 15 highs in a row on
  ; the strobe line.  Cycle ends is detected by 15 lows in a row.
  ;Mode A has 15 strobes in a cycle, Mode B has 5.
  ; Note that the 15 highs/lows for cycle detection may be too high for slow
  ; machines.  I havn't seen a problem yet, but it may exist...
  ;Multicontroller handling pisses me off;  each controller has five cycles
  ; with data in mode B format, as far as I can tell.  But where the hell does
  ; mode A come into play?
  ;For now, assuming mode A doesn't exist in multi-controller version

  FindCycle:
  mov al,cs:[gDump+di]        ;get next status byte
  inc di                      ;increment input pointer
  cmp di,200                  ;test for end of status block
  je SHORT SWNoFind           ;if it's the end, quit sub with error
  test al,00010000b           ;Check for nonzero bits
  jnz SHORT WMFCS1            ;
  xor cx,cx                   ;if zero, reset tick count
  jmp SHORT FindCycle         ;can't be pre-cycle
  WMFCS1:                     ;Possibly pre-cycle
  inc cx                      ;increment tick count
  cmp cx,15                   ;test for sufficient ticks for cycle start
  jne SHORT FindCycle         ;if insufficient, get next status byte
                              ;Yippie! it found a (probable) cycle!

  mov bp,0                    ;initialize bDump index

  FindStrobeLow:              ;Search for leading edge of data strobe
  mov al,cs:[gDump+di]        ;get next status byte
  inc di                      ;increment input pointer
  cmp di,200                  ;test for end of status block
  je SHORT SWNoFind           ;if it's the end, quit sub with error
  test al,00010000b           ;get "strobe" bit
  jnz SHORT FindStrobeLow     ;if it isn't zero, we're not there yet
  xor cx,cx                   ;initialize cycle end test count

  FindStrobeHigh:
  inc cx                      ;increment zero count
  cmp cx,0fh                  ;is it 15?
  je SWModeBCheck             ;if so, goto mode B check
  mov al,cs:[gDump+di]        ;get next status byte
  inc di                      ;increment input pointer
  cmp di,200                  ;test for end of status block
  je SHORT SWNoFind           ;if it's the end, quit sub with error
  test al,00010000b           ;get "strobe" bit
  jz SHORT FindStrobeHigh     ;if it is zero, we're not there yet
                              ;if not, we're there!  data bit is valid (probably)
  mov CS:[bDump+bp],al        ;preserve data for mode B
  inc bp                      ;increment cycle count/bDump index
  shl si,1                    ;set next output bit (mode A)
  test al,00100000b           ;test for button press (mode A)
  jnz SHORT NoButton          ;Button not pressed, so wait for next button
  or bx,si                    ;Button IS pressed, or the bit into the output
  NoButton:
  cmp bp,15                   ;Is Mode A done?
  je SHORT SMWDone            ;
  jmp SHORT FindStrobeLow     ;if it isn't, wait for the next button

  SMWDone:
  pop bp
  pop di
  pop si
  pop dx
  pop cx
  pop ax                      ;restore registers
  clc                         ;indicate no error
  ret                         ;return to calling procedure
  SWNoFind:
  ;error return.  Calling sub should re-dump status, or report "no sidewinder"
  pop bp
  pop di
  pop si
  pop dx
  pop cx
  pop ax                      ;restore registers
  stc                         ;indicate error
  ret
  SWModeBCheck:
  cmp bp,10
  je TwoDamnSW
  cmp bp,5                    ;Check strobe count (Mode B always has five)
  jne SHORT SWNoFind
  ;Handle mode B buttons

  mov bp,0
  DoModeB
  jmp SMWDone

  TwoDamnSW:
  ;First 5 cycles should be Pad #1, last 5 should be Pad #2
  mov bp,0
  DoModeB
  push bx
  mov bp,5
  DoModeB
  mov bp,bx
  pop bx
  jmp SMWDone
ENDP

DoModeB MACRO
  LOCAL NoUp,NoDn,NoLt,NoRt,NoA,NoB,NoC,NoX,NoY,NoZ,NoSt,NoM,NoL,NoR,NoParity
  mov bx,0                    ;Initialize output
  test CS:[bDump+bp],00100000b   ;Check bit 5 of Cycle 0
  jnz NoUp                    ;if zero, up is not pressed
  or bx,0000000000000010b     ;set Up bit in output
  NoUp:                       ;
  test CS:[bDump+bp],01000000b   ;continues the same for all buttons.
  jnz NoDn
  or bx,0000000000000100b
  NoDn:
  test CS:[bDump+bp],10000000b
  jnz NoRt
  or bx,0000000000001000b
  NoRt:
  test CS:[bDump+bp+1],00100000b
  jnz NoLt
  or bx,0000000000010000b
  NoLt:
  test CS:[bDump+bp+1],01000000b
  jnz NoA
  or bx,0000000000100000b
  NoA:
  test CS:[bDump+bp+1],10000000b
  jnz NoB
  or bx,0000000001000000b
  NoB:
  test CS:[bDump+bp+2],00100000b
  jnz NoC
  or bx,0000000010000000b
  NoC:
  test CS:[bDump+bp+2],01000000b
  jnz NoX
  or bx,0000000100000000b
  NoX:
  test CS:[bDump+bp+2],10000000b
  jnz NoY
  or bx,0000001000000000b
  NoY:
  test CS:[bDump+bp+3],00100000b
  jnz NoZ
  or bx,0000010000000000b
  NoZ:
  test CS:[bDump+bp+3],01000000b
  jnz NoL
  or bx,0000100000000000b
  NoL:
  test CS:[bDump+bp+3],10000000b
  jnz NoR
  or bx,0001000000000000b
  NoR:
  test CS:[bDump+bp+4],00100000b
  jnz NoSt
  or bx,0010000000000000b
  NoSt:
  test CS:[bDump+bp+4],01000000b
  jnz NoM
  or bx,0100000000000000b
  NoM:
  test CS:[bDump+bp+4],10000000b
  jnz NoParity
  or bx,1000000000000000b
  NoParity:
ENDM

   END
